#include "AbstractComposite.h"
#include "AbstractComponent.h"



AbstractComposite::AbstractComposite() :
bikerCount(-1)
{}


AbstractComponent* AbstractComposite::getBiker(int index){
	return children.at(index);
}

void AbstractComposite::addChild(AbstractComponent* child){
	children.push_back(child);
}

void AbstractComposite::removeChild(AbstractComponent* child){
	if(child->parent == this){
		child->parent = 0;
       // children.removeElement(child);
        changeNotification();
	}
}

void AbstractComposite::changeNotification(){
	bikerCount = -1;
	if(parent != 0)
		parent->changeNotification();	
}


int AbstractComposite::countBikers(){
	if(bikerCount!=-1)
           return bikerCount;
        int count = 0;
        for(int i =0; i<children.size(); i++){
            AbstractComponent* child = children.at(i);
            count += child->countBikers();
        }
        bikerCount = count;
        return bikerCount;	
}
